osgVolume::Layer Class Reference

`#include <Layer>`

Inheritance diagram for osgVolume::Layer:

## Public Member Functions

| Layer ()
| Layer (const Layer &, const osg::CopyOp &copyop=osg::CopyOp::SHALLOW_COPY)
| META_Object (osgVolume, Layer)
virtual void | setFileName (const std::string &filename)
virtual const std::string & | getFileName () const
void | setLocator (Locator *locator)
template<class T>
void | setLocator (const osg::ref_ptr< T > &locator)
Locator * | getLocator ()
const Locator * | getLocator () const
void | setDefaultValue (const osg::Vec4 &value)
const osg::Vec4 & | getDefaultValue () const
void | setMinFilter (osg::Texture::FilterMode filter)
osg::Texture::FilterMode | getMinFilter () const
void | setMagFilter (osg::Texture::FilterMode filter)
osg::Texture::FilterMode | getMagFilter () const
virtual osg::Image * | getImage ()
virtual const osg::Image * | getImage () const
void | setProperty (Property *property)
template<class T>
void | setProperty (const osg::ref_ptr< T > &p)
Property * | getProperty ()
const Property * | getProperty () const
void | addProperty (Property *property)
template<class T>
void | addProperty (const osg::ref_ptr< T > &p)
virtual bool | requiresUpdateTraversal () const
virtual void | update (osg::NodeVisitor &)
virtual void | dirty ()
virtual void | setModifiedCount (unsigned int)
virtual unsigned int | getModifiedCount () const
virtual osg::BoundingSphere | computeBound () const
Public Member Functions inherited from osg::Object
| Object ()
| Object (bool threadSafeRefUnref)
| Object (const Object &, const CopyOp &copyop=CopyOp::SHALLOW_COPY)
virtual Object * | cloneType () const =0
virtual Object * | clone (const CopyOp &) const =0
virtual bool | isSameKindAs (const Object *) const
virtual const char * | libraryName () const =0
virtual const char * | className () const =0
std::string | getCompoundClassName () const
virtual Node * | asNode ()
virtual const Node * | asNode () const
virtual NodeVisitor * | asNodeVisitor ()
virtual const NodeVisitor * | asNodeVisitor () const
virtual StateSet * | asStateSet ()
virtual const StateSet * | asStateSet () const
virtual StateAttribute * | asStateAttribute ()
virtual const StateAttribute * | asStateAttribute () const
virtual Uniform * | asUniform ()
virtual const Uniform * | asUniform () const
virtual Camera * | asCamera ()
virtual const Camera * | asCamera () const
virtual Drawable * | asDrawable ()
virtual const Drawable * | asDrawable () const
virtual Callback * | asCallback ()
virtual const Callback * | asCallback () const
virtual CallbackObject * | asCallbackObject ()
virtual const CallbackObject * | asCallbackObject () const
virtual UserDataContainer * | asUserDataContainer ()
virtual const UserDataContainer * | asUserDataContainer () const
virtual ValueObject * | asValueObject ()
virtual const ValueObject * | asValueObject () const
virtual Image * | asImage ()
virtual const Image * | asImage () const
virtual void | setThreadSafeRefUnref (bool threadSafe)
virtual void | setName (const std::string &name)
void | setName (const char *name)
const std::string & | getName () const
void | setDataVariance (DataVariance dv)
DataVariance | getDataVariance () const
virtual void | computeDataVariance ()
void | setUserDataContainer (osg::UserDataContainer *udc)
template<class T>
void | setUserDataContainer (const ref_ptr< T > &udc)
osg::UserDataContainer * | getUserDataContainer ()
const osg::UserDataContainer * | getUserDataContainer () const
osg::UserDataContainer * | getOrCreateUserDataContainer ()
virtual void | setUserData (Referenced *obj)
template<class T>
void | setUserData (const ref_ptr< T > &ud)
virtual Referenced * | getUserData ()
virtual const Referenced * | getUserData () const
template<typename T>
bool | getUserValue (const std::string &name, T &value) const
template<typename T>
void | setUserValue (const std::string &name, const T &value)
virtual void | resizeGLObjectBuffers (unsigned int)
virtual void | releaseGLObjects (osg::State *=0) const
template<typename T>
BoolValueObject UCharValueObject UShortValueObject UIntValueObject DoubleValueObject Vec3fValueObject Vec2dValueObject Vec4dValueObject PlaneValueObject MatrixdValueObject BoundingBoxdValueObject BoundingSpheredValueObject bool | getUserValue (const std::string &name, T &value) const
Public Member Functions inherited from osg::Referenced
| Referenced ()
| Referenced (bool threadSafeRefUnref)
| Referenced (const Referenced &)
Referenced & | operator= (const Referenced &)
bool | getThreadSafeRefUnref () const
OpenThreads::Mutex * | getRefMutex () const
int | ref () const
int | unref () const
int | unref_nodelete () const
int | referenceCount () const
ObserverSet * | getObserverSet () const
ObserverSet * | getOrCreateObserverSet () const
void | addObserver (Observer *observer) const
void | removeObserver (Observer *observer) const

## Protected Member Functions

virtual | ~Layer ()
Protected Member Functions inherited from osg::Object
virtual | ~Object ()
Protected Member Functions inherited from osg::Referenced
virtual | ~Referenced ()
void | signalObserversAndDelete (bool signalDelete, bool doDelete) const
void | deleteUsingDeleteHandler () const

## Protected Attributes

std::string | _filename
osg::ref_ptr< Locator > | _locator
osg::Vec4 | _defaultValue
osg::Texture::FilterMode | _minFilter
osg::Texture::FilterMode | _magFilter
osg::ref_ptr< Property > | _property
Protected Attributes inherited from osg::Object
std::string | _name
DataVariance | _dataVariance
osg::UserDataContainer * | _userDataContainer
Protected Attributes inherited from osg::Referenced
OpenThreads::AtomicPtr | _observerSet
OpenThreads::Atomic | _refCount

## Additional Inherited Members

Public Types inherited from osg::Object
enum | DataVariance { DYNAMIC , STATIC , UNSPECIFIED }
Static Public Member Functions inherited from osg::Referenced
static OpenThreads::Mutex * | getGlobalReferencedMutex ()
static void | setDeleteHandler (DeleteHandler *handler)
static DeleteHandler * | getDeleteHandler ()

## Detailed Description

Base class for representing a single layer of volume data.

## Constructor & Destructor Documentation

## Layer() [1/2]

osgVolume::Layer::Layer | ( |  | ) |

Referenced by osgVolume::CompositeLayer::addLayer(), osgVolume::CompositeLayer::getLayer(), osgVolume::CompositeLayer::getLayer(), Layer(), META_Object(), osgVolume::CompositeLayer::NameLayer::NameLayer(), and osgVolume::CompositeLayer::setLayer().

## Layer() [2/2]

osgVolume::Layer::Layer | ( | const Layer & | ,
|  | const osg::CopyOp & | copyop = osg::CopyOp::SHALLOW_COPY )

Copy constructor using CopyOp to manage deep vs shallow copy.

References Layer(), and osg::CopyOp::SHALLOW_COPY.

## ~Layer()

virtual osgVolume::Layer::~Layer | ( |  | ) |

protected virtual

## Member Function Documentation

## addProperty() [1/2]

template<class T>

void osgVolume::Layer::addProperty | ( | const osg::ref_ptr< T > & | p | ) |

inline

References addProperty(), and osg::ref_ptr< T >::get().

Referenced by addProperty().

## addProperty() [2/2]

void osgVolume::Layer::addProperty | ( | Property * | property | ) |

Add a property, automatically creating a CompositePorperty if one isn't already assigned.

## computeBound()

virtual osg::BoundingSphere osgVolume::Layer::computeBound | ( |  | ) | const

virtual

## dirty()

virtual void osgVolume::Layer::dirty | ( |  | ) |

inline virtual

increment the modified count."

Reimplemented in osgVolume::ImageLayer.

## getDefaultValue()

const osg::Vec4 & osgVolume::Layer::getDefaultValue | ( |  | ) | const

inline

References _defaultValue.

## getFileName()

virtual const std::string & osgVolume::Layer::getFileName | ( |  | ) | const

inline virtual

Get the file name of the layer.

Reimplemented in osgVolume::ImageLayer.

References _filename.

Referenced by osgVolume::CompositeLayer::addLayer().

## getImage() [1/2]

virtual osg::Image * osgVolume::Layer::getImage | ( |  | ) |

inline virtual

Return image associated with layer if supported.

Reimplemented in osgVolume::ImageLayer.

## getImage() [2/2]

virtual const osg::Image * osgVolume::Layer::getImage | ( |  | ) | const

inline virtual

Return const image associated with layer if supported.

Reimplemented in osgVolume::ImageLayer.

## getLocator() [1/2]

Locator * osgVolume::Layer::getLocator | ( |  | ) |

inline

References _locator.

## getLocator() [2/2]

const Locator * osgVolume::Layer::getLocator | ( |  | ) | const

inline

References _locator.

## getMagFilter()

osg::Texture::FilterMode osgVolume::Layer::getMagFilter | ( |  | ) | const

inline

Get the magnification texture filter to use when do texture associated with this layer.

References _magFilter.

## getMinFilter()

osg::Texture::FilterMode osgVolume::Layer::getMinFilter | ( |  | ) | const

inline

Get the minification texture filter to use when do texture associated with this layer.

References _minFilter.

## getModifiedCount()

virtual unsigned int osgVolume::Layer::getModifiedCount | ( |  | ) | const

inline virtual

Get modified count value.

Reimplemented in osgVolume::ImageLayer.

## getProperty() [1/2]

Property * osgVolume::Layer::getProperty | ( |  | ) |

inline

Get the Property that informs the VolumeTechnique how this layer should be rendered.

References _property.

## getProperty() [2/2]

const Property * osgVolume::Layer::getProperty | ( |  | ) | const

inline

Get the const Property that informs the VolumeTechnique how this layer should be rendered.

References _property.

## META_Object()

osgVolume::Layer::META_Object | ( | osgVolume | ,
|  | Layer | )

References Layer().

## requiresUpdateTraversal()

virtual bool osgVolume::Layer::requiresUpdateTraversal | ( |  | ) | const

inline virtual

Specify whether ImageLayer requires update traversal.

Reimplemented in osgVolume::CompositeLayer, and osgVolume::ImageLayer.

## setDefaultValue()

void osgVolume::Layer::setDefaultValue | ( | const osg::Vec4 & | value | ) |

inline

References _defaultValue.

## setFileName()

virtual void osgVolume::Layer::setFileName | ( | const std::string & | filename | ) |

inline virtual

Set the file name of the data associated with this layer.

Reimplemented in osgVolume::ImageLayer.

References _filename.

## setLocator() [1/2]

template<class T>

void osgVolume::Layer::setLocator | ( | const osg::ref_ptr< T > & | locator | ) |

inline

References osg::ref_ptr< T >::get(), and setLocator().

Referenced by setLocator().

## setLocator() [2/2]

void osgVolume::Layer::setLocator | ( | Locator * | locator | ) |

inline

References _locator.

## setMagFilter()

void osgVolume::Layer::setMagFilter | ( | osg::Texture::FilterMode | filter | ) |

inline

Set the magniification texture filter to use when do texture associated with this layer.

References _magFilter.

## setMinFilter()

void osgVolume::Layer::setMinFilter | ( | osg::Texture::FilterMode | filter | ) |

inline

Set the minification texture filter to use when do texture associated with this layer.

References _minFilter.

## setModifiedCount()

virtual void osgVolume::Layer::setModifiedCount | ( | unsigned int |  | ) |

inline virtual

Set the modified count value.

Reimplemented in osgVolume::ImageLayer.

## setProperty() [1/2]

template<class T>

void osgVolume::Layer::setProperty | ( | const osg::ref_ptr< T > & | p | ) |

inline

References osg::ref_ptr< T >::get(), and setProperty().

Referenced by setProperty().

## setProperty() [2/2]

void osgVolume::Layer::setProperty | ( | Property * | property | ) |

inline

Set the Property (or Properties via the CompositeProperty) that informs the VolumeTechnique how this layer should be rendered.

References _property.

## update()

virtual void osgVolume::Layer::update | ( | osg::NodeVisitor & |  | ) |

inline virtual

Call update on the Layer.

Reimplemented in osgVolume::CompositeLayer, and osgVolume::ImageLayer.

## Member Data Documentation

## _defaultValue

osg::Vec4 osgVolume::Layer::_defaultValue

protected

Referenced by getDefaultValue(), and setDefaultValue().

## _filename

std::string osgVolume::Layer::_filename

protected

Referenced by osgVolume::ImageLayer::getFileName(), getFileName(), osgVolume::ImageLayer::setFileName(), and setFileName().

## _locator

osg::ref_ptr<Locator> osgVolume::Layer::_locator

protected

Referenced by getLocator(), getLocator(), and setLocator().

## _magFilter

osg::Texture::FilterMode osgVolume::Layer::_magFilter

protected

Referenced by getMagFilter(), and setMagFilter().

## _minFilter

osg::Texture::FilterMode osgVolume::Layer::_minFilter

protected

Referenced by getMinFilter(), and setMinFilter().

## _property

osg::ref_ptr<Property> osgVolume::Layer::_property

protected

Referenced by getProperty(), getProperty(), and setProperty().

The documentation for this class was generated from the following file:

- osgVolume/Layer